mode(-1)
// Copyright (C) - lucien.povy@free.fr. Carantec 2014-2017.
// This file must be used under the terms of the GNU GPL v2.0 licence.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// https://www.gnu.org/licenses/licenses.en.html
// ==================================================================== 
mode(4);
//FACTORISATION DES POLYNÔMES.
//
//MACRO [f,g]=factors(poly).
//
s=%s;
num1=poly([1,2,3,4,5],"s","c")
[fac,gain]=factors(num1)
typfac=type(fac)
tygain=type(gain)
fvec=list2vec(fac)
typfvec=type(fvec)
prod([gain;fvec])
halt();
//
//MACRO F= polfact(poly).
//
num1
fac=polfact(num1)
typfac=type(fac)
halt();
//
//MACRO [res,g]=pfactors(poly)
//
num=poly([1 2 8 4 7 3 9],"s","c")
[res,g]=pfactors(num)
typg=type(g)
typres=type(res)
num2=g*res(1)*res(2)*res(3)
Diffpoly=num-num2
Vecnum=[g;list2vec(res)]
halt();
//
//MACRO [k,l,d,tn,td,ftn,ftd]=bodfact(poly,flag).
//
num3=num*(1+s*s)
[k,l,d,tn,td,ftn,ftd]=bodfact(num3,"y2")
[k,l,d,tn,td,ftn,ftd]=bodfact(num3,"y")
[k,l,d,tn,td,ftn,ftd]=bodfact(num3)
halt();
//
//FACTORISATION DES RATIONNELS et SYSTEMES.
//
//MACRO [fn,fd,g]=factors(RAT).
//
num=poly([0.2,2,5],"s")
den=poly([0.1,0.3,7],"s")
RAT=num/den
[fn,fd,g]=factors(RAT)
halt();
//
//MACRO [k,l,d,tn,td,ftn,ftd]=bodfact(rat,flag).
//
//SYSTEMES continus.
//
[k,l,d,tn,td,ftn,ftd]=bodfact(RAT,"y2")
[k,l,d,tn,td,ftn,ftd]=bodfact(RAT,"y")
[k,l,d,tn,td,ftn,ftd]=bodfact(RAT)
halt();
//
RAT1 = RAT*(2+s*s)
[k,l,d,tn,td,ftn,ftd]=bodfact(RAT1,"y2")
[k,l,d,tn,td,ftn,ftd]=bodfact(RAT1)
halt();
//
//SYSTEMES échantillonnés.
//
z=%z;
z=%z;num=poly([0.2,2,0.5],"z")
den=poly([1,1,0.6,0.3,0.8],"z")
RAT1=syslin("d",num,den)
[k,l,d,tn,td,ftn,ftd]=bodfact(RAT1)
k*(z-1)^l*z^d*(tn/td)
[k,l,d,tn,td,ftn,ftd]=bodfact(RAT1/z)
k*(z-1)^l*z^d*(tn/td)
halt();
//
//MACRO [fn,fd,g]=factors(RAT).
//
//SYSTEMES échantillonnés.
[tn,td,g]=factors(RAT1)
fnum=list2vec(tn)
fden=list2vec(td)
g*prod(fnum(:))/prod(fden(:))
halt();

