mode(-1)
// Copyright (C) - lucien.povy@free.fr. Carantec 2014-2017.
// This file must be used under the terms of the GNU GPL v2.0 licence.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// https://www.gnu.org/licenses/licenses.en.html
// ==================================================================== 
mode(4)
//DEMO HORNER AVEC DEUX VECTEURS
//
s=%s;
H=[1+s;(1+s+s*s);1/(2+3*s+s*s)]
f=[(1-s)/(1+s),1/s,4]
Mat=horner(H,f)
type(Mat)
halt();
//
//HORNER AVEC UN VECTEUR ET UN SCALAIRE OU UN RATIONNEL
//VERIFICATION
//
Mat1=horner(H,1+%i)
Mat2=horner(H,(1-s)/(1+s))
Mat3=horner(H,1/s)
Mat4=horner(H,4)
//
halt();
//
//CHANGEMENT DE VARIABLE.
//
w=poly(0,"w")//On introduit une autre variable.
fr=1+s+s*s
//
//ON CHANGE s en (w+1)/(w-1)).
//
frw=horner(fr,(w+1)/(w-1))
halt();
//
//RUFFINI-HORNER : calcul dérivées en un point.
//
P=poly([1,2,3,4],"s","c")
//point choisi : 0.5.
Q=horner(P,s+.5)
//poly et 3 dérivées en : 0.5.
coeQ=coeff(Q)
dP1=derivat(P),dP2=derivat(dP1),dP3=derivat(dP2)
C=horner([P,dP1,dP2,dP3],.5)
//
//COMPARAISON.
//[1,1,2,6]=[0!,1!,2!,3!]
CC=coeQ.*[1,1,2,6]
DiffC=CC-C
halt();



