mode(-1)
// Copyright (C) - lucien.povy@free.fr. Carantec 2014-2017.
// This file must be used under the terms of the GNU GPL v2.0 licence.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// https://www.gnu.org/licenses/licenses.en.html
// ==================================================================== 
mode(4);
//
//MARGE DE MODULE : OU MARGE DE GAIN-PHASE.
//
s=%s;g=syslin("c",0.4,s+s*s);gd=iodelay(g,1)
[mgp,fmgp] = m_marginrd(gd) //Marge de module, fréquence correspondante.
//
//VISUALISATION DU LIEU DE Nyquist.
//
nnyquist([g;gd],.05,1)//Le lieu de Nyquist des systèmes sans et avec retard.
//
//CERCLE CENTRE EN [-1,0] DE RAYON "mgp".
//
xarc(-1-mgp,mgp,2*mgp,2*mgp,0,64*360)
arc = get("hdl");//Récupération du "handle".
arc.line_style = 6;arc.foreground = 6;//Style, couleur.
halt();
//
//MARGE DE GAIN.
//
[mg,fmg] = g_marginrd(gd)//Marge de gain, fréquence correspondante.
//
//MARGE DE PHASE.
//
[mp,fmp] = p_marginrd(gd)//Marge de phase, fréquence correspondante.
//
//VISUALISATION DANS LE PLAN DE Black DES MARGES.
//
clf();
bblack(gd,0.05,0.3)
halt();
//
//MARGE DE MODULE.
//
[fmgp,gmgp,phimgp] = dbphifr(gd,fmgp)//Fréquence, gain, phase, à la fréquence "fmgp".

//
//TRACER DU SEGMENT CORRESPONDANT, (Marge de module).
//
xpoly([-180,phimgp],[0,gmgp]);
p = get("hdl"); p.foreground = 5; p.thickness = 3;p.mark_style = 9;
halt();
//
//MARGE DE GAIN.
//
[fmg,mg,pmg] = dbphifr(gd,fmg)//Fréquence, gain, phase, à la fréquence "fmg".
//
//TRACER DU SEGMENT CORRESPONDANT, (Marge de gain).
//
xpoly([-180,pmg],[0,mg]);
p = get("hdl"); p.foreground = 3; p.thickness = 3;p.mark_style = 9;
halt();
//
//MARGE DE PHASE.
//
[fmp,mp,pmp] = dbphifr(gd,fmp)//Fréquence, gain, phase, à la fréquence "fmp".
//
//TRACER DU SEGMENT CORRESPONDANT, (Marge de phase).
//
xpoly([-180,pmp],[0,mp]);
p = get("hdl"); p.foreground = 4; p.thickness = 3;p.mark_style = 9;
halt();



