// Copyright (C) - lucien.povy@free.fr. Carantec 2014-2016.
// This file must be used under the terms of the GNU GPL v2.0 licence.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// https://www.gnu.org/licenses/licenses.en.html
// ====================================================================
// We change the symbolic variable of (1x1) iodelay system, now (var_new) == var/delay.
// ==================================================================== 
function h1d = chang_varia(hd)
if typeof(hd) <> "rd" then
  error(msprintf(_("%s: Wrong type for input argument %d: SISO iodelay system expected.\n"),"chang_varia",1))
end
if or(size(hd) <> [1,1]) then
  error(95,1)
end
h = hd.H;delay = hd.iodelay;
var = poly(0,varn(h));
h1 = horner(h,var/delay);
h1.dt = "c";
h1d = iodelay(h1,1);
endfunction
