function [fmat,dbmat,phmat] = Gresismat(fr,c,d)
//c vecteur colonne des ordres de drivation (n,1), "c"=alpha.
//d ici je prends un scalaire , mais on peut changer en vecteur.
//fr vecteur ligne des frquences (1,m).
//fmat matrice des frquences retournes (n,m).
//dbmat matrice (n,m) des gains. 
//phmat matrice (n,m) des phases.
n = length(c); m = length(fr);
fmat = ones(n,1)*fr;
resden = [];
for i = 1:n 
  ci = c(i); 
  resdeni = (2*%pi*%i*fr)^ci; 
  resden = [resden;resdeni];
end
resnum = d*resden;//d scalaire ici.
num = ones(n,m) + resnum;
den = ones(n,m) + resden;
dbmat=(20/log(10))*(log(abs(num))-log(abs(den)));
phmat=phasemag(num)-phasemag(den);
endfunction
