function[fexp,dbexp,phexp]=Gexplicite(fr,a)
//a vecteur colonne des ordres de dérivation (n,1).
//fr vecteur ligne des fréquences (1,m).
//fexp matrice des fréquences retournée (n,m).
//dbexp matrice (n,m) des gains.
//phexp matrice (n,m) des phases.
  n = length(a);
  m = length(fr)
  fexp = ones(n,1)*fr;
  res = [];
  for i = 1:n 
    ai = a(i);
    resai = (2*%pi*%i*fr)^ai;
    res = [res;resai];
  end
  den = ones(n,m) + res;
  dbexp = -(20/log(10))*log(abs(den));
  phexp = -phasemag(den);
endfunction
 
