function[fimp,dbimp,phimp]=Gimplicite(fr,b)
//b vecteur colonne des ordres de dérivation (n,1). 
//fr vecteur ligne des fréquences (1,m). 
//fimp matrice des fréquences retournées (n,m). 
//dbimp matrice (n,m) des gains. 
//phimp matrice (n,m) des phases. 
  n = length(b); m = length(fr); 
  fimp = ones(n,1)*fr; 
  res = []; 
  for i = 1:n 
    bi = b(i); 
    resbi = (ones(1,m)+2*%pi*%i*fr)^bi; 
    res = [res;resbi]; 
  end 
  den = res; 
  dbimp = -(20/log(10))*log(abs(den)); 
  phimp = -phasemag(den); 
endfunction

 
